

  const
    ausgabebits : array[0..7] of integer = (1,2,4,8,16,32,64,128);

  var
    vondraussen : integer;
    nachdraussen : integer;
    ausgabe : array[0..7] of boolean;
    eingabe : array[0..7] of boolean;
    tasten  : array[1..4] of boolean;

  procedure initialisiereports(var output, input : integer);
    var
      datei : text;
      eingang, ausgang : string[3];
      dummy : integer;

    begin
      if ibm then
        begin
          assign(datei,ioportdatei);
          (*$I-*)
          reset(datei);
          (*$I+*)
          if ioresult = 0 then
            begin
              readln(datei,ausgang);
              readln(datei,eingang);
              val(ausgang,output,dummy);
              val(eingang,input,dummy);
            end;
          close(datei);
        end;
      if cpm then port[kontrollport] := kontrollwort;
    end;

  procedure gibanperipherieaus;
    var
      z : integer;

    begin
      nachdraussen := 0;
          for z := 0 to 7 do
            begin
              if ausgabe[z] then nachdraussen := nachdraussen + ausgabebits[z];
            end;
      if cpm then port[ausgangsport] := nachdraussen;
      if ibm then port[ibmausgangsport] := nachdraussen;
    end;

  procedure holeinterfacedaten;
    var
      z : integer;
    begin
                                (* Eingangswerte von der Peripheie holen *)

      if ibm then
        begin
          vondraussen := port[ibmeingangsport];
          if ibminvers1 then
            eingabe[1] := vondraussen and ibmbitrein1 = 0
          else
            eingabe[1] := vondraussen and ibmbitrein1 <> 0;
          if ibminvers2 then
            eingabe[2] := vondraussen and ibmbitrein2 = 0
          else
            eingabe[2] := vondraussen and ibmbitrein2 <> 0;
          if ibminvers3 then
            eingabe[3] := vondraussen and ibmbitrein3 = 0
          else
            eingabe[3] := vondraussen and ibmbitrein3 <> 0;
          if ibminvers4 then
            eingabe[4] := vondraussen and ibmbitrein4 = 0
          else
            eingabe[4] := vondraussen and ibmbitrein4 <> 0;
        end;
      if cpm then
        begin
          vondraussen := port[eingangsport];
          eingabe[1] := vondraussen and bitrein1 <> 0;
          eingabe[2] := vondraussen and bitrein2 <> 0;
          eingabe[3] := vondraussen and bitrein3 <> 0;
          eingabe[4] := vondraussen and bitrein4 <> 0;
        end;
      for z := 1 to 4 do eingabe[z] := eingabe[z] or tasten[z];
    end;
